=== debian/changelog ===
cpp-httplib (0.16.3+ds-2) unstable; urgency=medium

  * d/patches: bump minimum Meson version to 0.62.0
  * d/patches: fix SSLClientServerTest.* tests with OpenSSL 3.2.0

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 17 Sep 2024 16:33:49 +0200

cpp-httplib (0.16.3+ds-1) unstable; urgency=medium

  * Update to new upstream version 0.16.3+ds.
  * Upload to unstable
  * d/control: declare dpkg-build-api = 1.
    This switches the default for Rules-Requires-Root to "no", hence setting
    it explicitly is no longer needed.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 18 Aug 2024 19:27:08 +0200

cpp-httplib (0.16.0+ds-1) experimental; urgency=medium

  * Update to new upstream version 0.16.0+ds.
  * d/copyright: update CMake files info

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 09 Jul 2024 21:45:50 +0200
