=== debian/changelog ===
cpp-httplib (0.18.7-1) unstable; urgency=medium

  * Update to new upstream version 0.18.7.
  * Upload to unstable
  * d/control: use my @debian.org email address
  * d/rules: copy missing meson test files

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 11 Mar 2025 18:18:06 +0100

cpp-httplib (0.18.0+ds-1) experimental; urgency=medium

  * Update to new upstream version 0.18.0+ds.
  * d/control: libcpp-httplib0.16 -> libcpp-httplib0.18
  * d/control: apply X-Style: black
  * d/control: add build dependency on libcurl-dev

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 17 Sep 2024 17:33:26 +0200
