=== debian/changelog ===
cpp-httplib (0.20.1+ds-3) experimental; urgency=low

  * Third time's the charm

 -- Andrea Pappacoda <tachi@debian.org>  Fri, 13 Jun 2025 15:22:45 +0200

cpp-httplib (0.20.1+ds-2) experimental; urgency=low

  * Re-try git-debpush upload

 -- Andrea Pappacoda <tachi@debian.org>  Fri, 13 Jun 2025 15:14:20 +0200

cpp-httplib (0.20.1+ds-1) experimental; urgency=low

  * Update to new upstream version 0.20.1+ds.
  * d/control: libcpp-httplib0.18 -> libcpp-httplib0.20

 -- Andrea Pappacoda <tachi@debian.org>  Thu, 05 Jun 2025 15:57:30 +0200
