## cpp-httplib 0.25.0+ds

=== debian/changelog ===
cpp-httplib (0.25.0+ds-1) experimental; urgency=medium

  * Update to new upstream version 0.25.0+ds.

  * Fix numerous CVEs (Closes: #1109340):
    - CVE-2025-52887 (Unlimited number of HTTP headers causes memory leak).
      Version 0.22.0 adds a limit to the number of headers which can be passed
      in an HTTP request, mitigating a possible DoS due to memory exhaustion.

    - CVE-2025-53628 (HTTP Header Smuggling due to insecure trailers merge).
      Version 0.23.0 changes the way HTTP trailer fields are handled so to
      avoid an attacker to modify headers with prohibited trailers.

    - CVE-2025-53629 (Unbounded Memory Allocation in Chunked Requests).
      Version 0.23.0 complements the fix for CVE-2025-46728, actually solving
      memory exhaustion attacks via chucked HTTP requests.

  * d/control: libcpp-httplib0.20 -> libcpp-httplib0.25
  * d/changelog: mention CVE-2025-46728 in 0.20.1+ds-1 changelog entry.
  * d/rules: remove redundant file copy

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 16 Aug 2025 20:27:58 +0200
