=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/cpp-httplib
 X-Style: black
 
-Package: libcpp-httplib0.20
+Package: libcpp-httplib0.25
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -43,7 +43,7 @@
  ${misc:Pre-Depends},
 Depends:
  libbrotli-dev,
- libcpp-httplib0.20 (= ${binary:Version}),
+ libcpp-httplib0.25 (= ${binary:Version}),
  libssl-dev,
  zlib1g-dev,
  ${misc:Depends},
